Leetcode 139. Word Break

Given a non-empty string s and a dictionary wordDict containing a list of non-empty words, determine if s can be segmented into a space-separated sequence of one or more dictionary words.

Note:

The same word in the dictionary may be reused multiple times in the segmentation.
You may assume the dictionary does not contain duplicate words.
Example 1:

Input: s = “leetcode”, wordDict = [“leet”, “code”]
Output: true
Explanation: Return true because “leetcode” can be segmented as “leet code”.
Example 2:

Input: s = “applepenapple”, wordDict = [“apple”, “pen”]
Output: true
Explanation: Return true because “applepenapple” can be segmented as “apple pen apple”. Note that you are allowed to reuse a dictionary word.

method 1 Brute force

暴力解法,但是会超时
这是因为后面会频繁分解前面已经分解过的substring,在这部分耗时比较多

class Solution {
public:
    bool helper(unordered_set<string>& dict, string s){
        if(s == "" || dict.count(s))
            return true;
        
        bool res = false;
        for(int i = 1; i < s.size(); i++){
            string second = s.substr(i);
            string first = s.substr(0,i);
            res |= (helper(dict, first) && helper(dict, second));
            if(res){
                dict.insert(s);
                dict.insert(second + first);
                return true;
            }
        }
        
        return res;
    }
    
    bool wordBreak(string s, vector<string>& wordDict) {
        unordered_set<string> dict(wordDict.begin(), wordDict.end());
        
        return helper(dict, s);
        
    }
};

method 2 dp

dp[i]表示以第i个位置结尾的字符串是有效的,那么只需要考虑i-j之间的字符串是否有效。
这样后面处理时,并不会重复前面已经处理过的结果。

bool wordBreak(string s, vector<string>& wordDict) {
        unordered_set<string> dict(wordDict.begin(), wordDict.end());
        if(dict.size()==0) return false;
        
        vector<bool> dp(s.size()+1,false);
        dp[0]=true;
        
        for(int i=1;i<=s.size();i++)
        {
            for(int j=i-1;j>=0;j--)
            {
                if(dp[j])
                {
                    string word = s.substr(j,i-j);
                    if(dict.find(word)!= dict.end())
                    {
                        dp[i]=true;
                        break; //next i
                    }
                }
            }
        }
        
        return dp[s.size()];
        
    }

summary

  1. method 1 超时的原因主要是它从第i个位置,从两头同时处理,导致重复,method 2 只从一个方向处理,就算有反复,那也在当前范围内反复
  2. dp[i]:以i结尾的属性
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值